﻿using System;
using System.Collections.ObjectModel;

namespace TestApp
{
    public class TDataCollection : ObservableCollection<TData>
    {
        #region Constructor

        public TDataCollection()
        {
        }

        public TDataCollection(int loadSize)
        {
            this.LoadData(loadSize);
        }

        #endregion // Constructor

        #region LoadData

        public void LoadData(int loadSize)
        {
            for (int i = 0; i < loadSize; i++)
            {
                int intData = i;
                bool boolData = i % 2 == 0;
                double doubleData = i * 1.5;
                DateTime dateTimeData = new DateTime(2009, 5, i / 24 + 1, i % 24, 0, 0);

                string stringData = string.Format("String {0}", i);
                Uri uriData = new Uri("http://infragistics.com");
                TDataCollection dataItems = null;

                if (boolData)
                {
                    dataItems = new TDataCollection();

                    dataItems.Add(new TData
                    {
                        Int = 1,
                        Double = i,
                        Bool = true,
                        String = "Str",
                        DateTime = DateTime.Now,
                        Uri = new Uri("http://infragistics.com")
                    });

                    dataItems.Add(new TData
                    {
                        Int = 2,
                        Double = i,
                        Bool = false,
                        String = null,
                        DateTime = DateTime.Now,
                        Uri = null
                    });

                    dataItems.Add(new TData
                    {
                        Int = 3,
                        Double = i * 2.5,
                        Bool = false,
                        String = "str",
                        DateTime = DateTime.Now,
                        Uri = new Uri("http://infragistics.com")
                    });
                }

                this.Add(new TData
                {
                    Int = intData,
                    Double = doubleData,
                    Bool = boolData,
                    String = stringData,
                    DateTime = dateTimeData,
                    Uri = uriData,
                    DataItems = dataItems
                });
            }
        }

        #endregion // LoadData
    }
}
